SystemOrganization addCategory: #'Spec-Tools-ChangeSorter'!
SystemOrganization addCategory: #'Spec-Tools-Monticello'!
SystemOrganization addCategory: #'Spec-Tools-Senders'!
SystemOrganization addCategory: #'Spec-Tools-VersionBrowser'!
SystemOrganization addCategory: #'Spec-Tools-Editor'!

!String methodsFor: '*Spec-Tools' stamp: 'BenjaminVanRyseghem 7/3/2012 14:29'!
firstWord
	| start end |
	start := self findFirst: [ :chr| chr isSeparator not ].
	end := self findFirst: [ :chr| chr isSeparator ].
	end isZero
		ifTrue: [^ self ].
	
	^ self copyFrom: start to: end! !

DynamicComposableModel subclass: #SubwidgetItem
	instanceVariableNames: 'model initialExtent validated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!SubwidgetItem class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 04:20'!
spec
	<spec>
	
	^ SpecLayout composed 
		newRow: [:r |
			r
				add: #instVarName;
				add: #classChooser;
				newColumn: [:c | c add: #ok ] width: 75 ] 
		height: 25;
		send: #borderWidth: withArguments: { 1 };
		yourself! !

!SubwidgetItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 02:23'!
addInLayout: aColumn

	aColumn 
		add: self text getText asSymbol
		origin: (self x0Field getText squeezeOutNumber @ self y0Field getText squeezeOutNumber)
		corner: (self x1Field getText squeezeOutNumber @ self y1Field getText squeezeOutNumber)! !

!SubwidgetItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 22:31'!
buildClassItems

	^ AbstractBasicWidget allSubclasses collect: [:class |
		DropListItem 
			named: class name
			do: [ ]] ! !

!SubwidgetItem methodsFor: 'transformation' stamp: 'BenjaminVanRyseghem 7/11/2012 04:02'!
deleteMe
	| name |
	
	name := self text getText.
	self validated: false.
	self widgets removeAll.
	self initializeWidgets.
	self model ifNotNil: [:m | m removeInstVar: name ].
	self needFullRebuild: false.
	self buildWithSpec.
	! !

!SubwidgetItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 01:56'!
initialExtent 

	^ initialExtent! !

!SubwidgetItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 03:36'!
initialize
	"Initialization code for SubwidgetItem"

	super initialize.
	
	model := nil asValueHolder.
	initialExtent := 400@25.
	validated := false asValueHolder.! !

!SubwidgetItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 22:55'!
initializeWidgets 

	self instantiateModels: #(
		instVarName 	TextInputFieldModel
		classChooser	DropListModel
		ok 				ButtonModel ).
					
	self instVarName 
		ghostText: 'name';
		entryCompletion: nil;
		autoAccept: true;
		acceptBlock: [:t | self ok enabled: t isEmpty not ].
		
	self classChooser items: self buildClassItems.
	
	self ok 
		label: 'create';
		state: false;
		enabled: false;
		action: [ self transform ]! !

!SubwidgetItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 22:39'!
model

	^ model contents! !

!SubwidgetItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 22:39'!
model: anObject

	model contents: anObject! !

!SubwidgetItem methodsFor: 'transformation' stamp: 'BenjaminVanRyseghem 7/11/2012 04:09'!
newLayout

	^ SpecLayout composed 
		newColumn: [:c |
			c
				newRow: [:r | 
					r 
						add: #text;
						newColumn: [:c1 | c1 add: #remove ] 
						width: 30 ]
				height: 25;
				newRow: [:r | 
					r 
						newColumn: [:c1 | c1 add: #x0 ] 
						width: 30;
						add: #x0Field;
						newColumn: [:c1 | c1 add: #y0 ] 
						width: 30;
						add: #y0Field;
						newColumn: [:c1 | c1 add: #x1 ] 
						width: 30;
						add: #x1Field;
						newColumn: [:c1 | c1 add: #y1 ] 
						width: 30;
						add: #y1Field ]
				height: 25 ];
		yourself! !

!SubwidgetItem methodsFor: 'transformation' stamp: 'BenjaminVanRyseghem 7/11/2012 04:05'!
transform
	| name class |

	name := self instVarName getText asString.
	self validated: true.
	class := self classChooser selectedItem label asSymbol.

	self widgets removeAll.
	self instantiateModels: #(
		text 		TextInputFieldModel
		remove 	ButtonModel
		x0			LabelModel
		x0Field 		TextInputFieldModel
		y0			LabelModel
		y0Field 		TextInputFieldModel
		x1			LabelModel
		x1Field 		TextInputFieldModel
		y1			LabelModel
		y1Field 		TextInputFieldModel ).
			
	self text 
		text: name;
		enabled: false.
		
	self remove
		label: 'x';
		state: false;
		action: [ self deleteMe ].
		
	self x0 text: 'x0'.
	self y0 text: 'y0'.
	self x1 text: 'x1'.
	self y1 text: 'y1'.
		
	self x0Field 
		text: '0';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	self y0Field 
		text: '0';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	self x1Field 
		text: '1';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	self y1Field 
		text: '1';
		autoAccept: true;
		acceptBlock: [ self model ifNotNil: [:m | m rebuild ]].
	
	self needRebuild: false.
	initialExtent :=  400@50.
	self buildWithSpecLayout: self newLayout.
	self model ifNotNil: [:m | m addInstVarNamed: name forClassName: class ].! !

!SubwidgetItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 03:34'!
validated

	^ validated contents! !

!SubwidgetItem methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 03:34'!
validated: aBoolean

	validated contents: aBoolean! !

AbstractTool subclass: #ChangeSorterModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterModel commentStamp: '<historical>' prior: 0!
A ChangeSorterModel is a model used by Change Sorter UIs for computation!

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
addPreambleTo: aChangeSet

	aChangeSet assurePreambleExists! !

!ChangeSorterModel methodsFor: 'environment' stamp: ''!
allChanges

	^ ChangeSet allChangeSets reverse! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildChangeSetDescriptionFor: changeSet
		
	^ changeSet
		ifNil: [ '' ] 
		ifNotNil: [ changeSet preambleString ifNil: ['']]! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildClassDescriptionFor: changeSet class: class
	| stream |

	stream := (String new: 100) writeStream.
		(changeSet classChangeAt: class name)
			do: [:each | 
				each = #remove
					ifTrue: [ stream nextPutAll: 'Entire class was removed.'; cr ].
				each = #addedThenRemoved
					ifTrue: [ stream nextPutAll: 'Class was added then removed.'; cr ].
				each = #rename
					ifTrue: [ stream nextPutAll: 'Class name was changed.'; cr ].
				each = #add
					ifTrue: [ stream nextPutAll: 'Class definition was added.'; cr ].
				each = #change
					ifTrue: [ stream nextPutAll: 'Class definition was changed.'; cr ].
				each = #reorganize
					ifTrue: [ stream nextPutAll: 'Class organization was changed.'; cr ].
				each = #comment 
					ifTrue: [ stream nextPutAll: 'New class comment.'; cr ]].
		^ stream contents! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff

	| changeType code |
	changeType := changeSet atSelector: selector class: class name.
	
	changeType == #remove
		ifTrue: [^ 'Method has been removed (see versions)'].
	changeType == #addedThenRemoved
		ifTrue: [^ 'Added then removed (see versions)']. 
	class
		ifNil: [^ 'Method was added, but cannot be found!!'].
	(class includesSelector: selector)
		ifFalse: [^ 'Method was added, but cannot be found!!'].
	code := class sourceCodeAt: selector.
	prettyPrint
		ifTrue: [ code := class prettyPrinterClass
							format: code
							in: class
							notifying: nil ].						
	showDiff
		ifTrue: [ code := self diffFromPriorSourceFor: code ].
		
	^ code asText makeSelectorBoldIn: class! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
copyAllChangesFrom: source to: destination

	destination assimilateAllChangesFoundIn: source! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
copyClass: aClass from: source to: destination

	destination absorbClass: aClass name from: source.! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
copySelector: selector inClass: class from: source to: destination

	destination
		absorbMethod: selector 
		class: class 
		from:source! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
createNewSet

	^ ChangeSet newChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
fileOutClass: aClass from: aChangeSet
	"this is a hack!!!! makes a new change set, called the class name, adds author initials to try to make a unique change set name, files it out and removes it. kfr 16 june 2000"
	"Method copied from ChangeSorter"
	| aSet |
	"File out the selected class set."
     aSet := ChangeSet newChangeSet: aClass name.
	aSet ifNil:[ ^self ].
	aSet absorbClass: aClass name from: aChangeSet.
	aSet fileOut.
	ChangeSet removeChangeSet: aSet.! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
fileOutSelector: selector from: aClass
	
	aClass fileOutMethod: selector! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
findChangeSetIn: aCollectionOfChangeSets
	"Search for a changeSet by name.  Pop up a menu of all changeSets whose name contains the string entered by the user.  If only one matches, then the pop-up menu is bypassed"
	| index pattern candidates nameList |
	self okToChange ifFalse: [^ self].
	pattern := UIManager default request: 'ChangeSet name or fragment?'.
	pattern isEmptyOrNil ifTrue: [^ self].
	nameList := aCollectionOfChangeSets collect: #name.
	candidates := aCollectionOfChangeSets select:
			[:c | (nameList includes: c name) and: 
				[c name includesSubstring: pattern caseSensitive: false]].
	candidates size = 0 ifTrue: [ ^ Beeper beep ].
	candidates size = 1 ifTrue: [ ^ candidates first ].
	index := UIManager default chooseFrom: (candidates collect: [:each | each name]).
	index = 0 ifFalse: [ ^ (candidates at: index) ].! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
forgetSelector: selector inClass: aClass fromChangeSet: aChangeSet

	aChangeSet
			removeSelectorChanges: selector 
			class: aClass! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
removeChangeSet: aChangeSet prompting: doPrompt
	"Completely destroy my change set.  Check if it's OK first, and if doPrompt is true, get the user to confirm his intentions first."

	| message aName changeSetNumber msg |
	aName := aChangeSet name.
	aChangeSet okayToRemove ifFalse: [^ self]. "forms current changes for some project"
	(aChangeSet isEmpty or: [doPrompt not]) ifFalse:
		[message := 'Are you certain that you want to 
remove (destroy) the change set
named  "', aName, '" ?'.
		(self confirm: message) ifFalse: [^ self]].

	doPrompt ifTrue:
		[msg := aChangeSet hasPreamble
			ifTrue:
				[aChangeSet hasPostscript
					ifTrue:
						['a preamble and a postscript']
					ifFalse:
						['a preamble']]
			ifFalse:
				[aChangeSet hasPostscript
					ifTrue:
						['a postscript']
					ifFalse:
						['']].
		msg isEmpty ifFalse:
			[(self confirm: 
'Caution!!  This change set has
', msg, ' which will be
lost if you destroy the change set.
Do you really want to go ahead with this?') ifFalse: [^ self]]].

	"Go ahead and remove the change set"
	changeSetNumber := aChangeSet name initialIntegerOrNil.
	changeSetNumber ifNotNil: [SystemVersion current unregisterUpdate: changeSetNumber].
	ChangeSet removeChangeSet: aChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
removeClass: class from: changeSet

	changeSet removeClassChanges: class.! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
removePostscriptFrom: aChange

	(aChange hasPostscript and: [ aChange postscriptHasDependents ]) ifTrue:
		[^ self inform:
'Cannot remove the postscript right
now because there is at least one
window open on that postscript.
Close that window and try again.'].

	aChange removePostscript.! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
rename: aChangeSet
	"Store a new name string into the selected ChangeSet.  reject duplicate name; allow user to back out"

	| newName |
	newName := UIManager default request: 'New name for this change set'
						initialAnswer: aChangeSet name.
						
	(newName = aChangeSet name or: [newName isEmptyOrNil]) ifTrue:
			[ ^ Beeper beep ].

	(ChangeSet named: newName) ifNotNil:
			[ ^ UIManager default inform: 'Sorry that name is already used' ].

	aChangeSet name: newName.
	^ aChangeSet! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
setContentsOfChangeSet: changeSet forClass: class andSelector: selector prettyPrint: prettyPrint showDiff: showDiff 
	"return the source code that shows in the bottom pane"
	| strm changeType code |

	
	class
		ifNil: [
			"Only the change set is currently selected"
			^ self buildChangeSetDescriptionFor: changeSet ].
	selector isNil
		ifTrue: [ 
			"class is selected but not the selector"
			^ self buildClassDescriptionFor: changeSet class: class ]
		ifFalse: [
			"a class and a selector are selected"
			^ self buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff ]! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
setCurrentChangeSet: aChangeSet

	ChangeSet newChanges: aChangeSet! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
submerge: source into: destination
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	|   message |
	source == destination
		ifTrue: [ ^ false ].
	source isEmpty
		ifTrue: [ 
			self inform: 'Nothing to copy.  To remove,
simply choose "remove".'.
			^ false ].

	source okayToRemove ifFalse: [^ false].
	message := 'Please confirm:  copy all changes
in "', source name, '" into "', destination name, '"
and then destroy the change set
named "', source name, '"?'.
 
	(self confirm: message) ifFalse: [^ false].

	(source hasPreamble or: [source hasPostscript]) ifTrue:
		[(self confirm: 
'Caution!!  This change set has a preamble or
a postscript or both.  If you submerge it into
the other side, these will be lost.
Do you really want to go ahead with this?') ifFalse: [^ false]].

	self copyAllChangesFrom: source to: destination.
	self removeChangeSet: source prompting: false.
	^ true! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
substractFrom: source to: destination

	source forgetAllChangesFoundIn: destination.! !

DiffMethodReferenceConverter subclass: #DiffChangeRecordConverter
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-VersionBrowser'!

!DiffChangeRecordConverter commentStamp: '<historical>' prior: 0!
A DiffChangeRecordConverter is a converter used to show the diff between two methodreferences!

!DiffChangeRecordConverter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/3/2012 14:30'!
priorVersionOfAMethod: aChangeRecord
	| index |
	
	list := referencesList sorted: [:a :b | a timeStamp > b timeStamp ].
	index := list indexOf: aChangeRecord .
	^ list at: index+1 ifAbsent: [ aChangeRecord ]! !

Object subclass: #ConfigurationGenerator
	instanceVariableNames: 'repository workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!ConfigurationGenerator commentStamp: '<historical>' prior: 0!
Probably to be removed to use metacello toolbox!

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:00'!
addMetacelloBaseline
	| baselineNumber existingBaselines msg selectorName  addedPackages package stream packagePattern |
	
	"0 -- must have a repository selected"
	repository isNil 
		ifTrue: [ 
			UIManager default inform: 'Please select a repository and try again'. 
			^self ].
	"1 -- Selecting baseline name"
	existingBaselines := self baseLines. 
	
	existingBaselines size > 0  
		ifTrue: [msg := 'Current baselines:', String cr, (existingBaselines inject: '' into: [:sum :el | sum, el, String cr]), 'Enter a new baseline number']
		ifFalse: [msg := 'Enter a new baseline number ("-baseline" will be automatically added)'].
		
	baselineNumber := UIManager default request: msg initialAnswer: '1.0'.
	baselineNumber ifNil: [ ^ self ].
	
	"2 -- add package names"
	addedPackages := OrderedCollection new.
	packagePattern := UIManager default request: 'Please enter a pattern to filter package names' initialAnswer: '*'.
	[ | packageNames workingCopies |
	 packageNames := OrderedCollection new.
	workingCopies := OrderedCollection new.
	self workingCopies do: [:pkg | 
		((packagePattern match: pkg package name) and: [ (addedPackages includes: pkg package name) not ])
			ifTrue: [ 
				packageNames add: pkg package name.
				workingCopies add: pkg ]].
	 package := 
		UIManager default 
			chooseFrom: packageNames
			values: workingCopies
			title: 'Add dependent package (cancel to stop)'.
	 package ifNotNil: [addedPackages add: package package name ]
	] doWhileTrue: [ package notNil ].

	
	"3 -- Creating baseline"
	selectorName := baselineNumber copyWithoutAll: '.-'.
	stream := WriteStream on: String new.
	stream nextPutAll: 'baseline'.
	stream nextPutAll: selectorName.
	stream nextPutAll: ': spec 
        <version: '''.
	stream nextPutAll: baselineNumber.
	stream nextPutAll: '-baseline''>
        
        spec for: #common do: [
                spec blessing: #baseline.
                spec repository: '''.

	stream nextPutAll: repository description.
	stream nextPutAll: '''.    
                "spec 
                        package: ''Example-Core'';
                        package: ''Example-Tests'' with: [ spec requires: ''Example-Core'' ]"
'.
	addedPackages 
		do: [:pName | stream nextPutAll: '			spec package: ''', pName, '''.', String cr].
	stream nextPutAll: '                ].'.

	self configurationClass compile: stream contents classified: 'baselines'.
! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
baseLines 
	| existingBaselines |
	existingBaselines := self configurationClass methods select: [:cm | cm selector beginsWith: 'baseline'].
	existingBaselines := (existingBaselines collect: [:m | m pragmas first argumentAt: 1]) asSortedCollection.
	^ existingBaselines! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
browseConfiguration
	self configurationClass browse! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
configurationClass
	^ Smalltalk globals at: workingCopy package name asSymbol ! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createDevelopmentVersion
	self hasAnyBaseline 
		ifFalse: [ UIManager default inform: 'Please, define a baseline first'. ^ self ].
	^ self createVersionForBlessing: #development! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createReleaseVersion
	self hasAnyBaseline 
		ifFalse: [ UIManager default inform: 'Please, define a baseline first'. ^ self ].
		
	^ self createVersionForBlessing: #release! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createVersionForBlessing: blessingSelector
	"blessingSelector = #release or #development"
	 
	| existingVersions msg initialAnswer newVersionNumber selectorName stream dependentPackages mcWorkingCopy |
	existingVersions := self configurationClass methods select: [:cm | cm selector beginsWith: 'version'].
	existingVersions := (existingVersions collect: [:m | m pragmas first argumentAt: 1]) asSortedCollection.
	
	msg := ''.
	existingVersions size > 4
		ifTrue: [ 
			msg := 'Last 4 versions: ', 
			(existingVersions copyFrom: (existingVersions size - 4) to: existingVersions size)
				 asArray printString, String cr ].
	
	existingVersions size > 0
		ifTrue: [ initialAnswer := existingVersions last, '.1' ]
		ifFalse: [ initialAnswer := '1.0' ].
	
	newVersionNumber := UIManager default request: msg initialAnswer: initialAnswer.
	newVersionNumber ifNil: [ ^ self ].

	selectorName := newVersionNumber copyWithoutAll: '.-'.
	stream := WriteStream on: String new.
	stream nextPutAll: 'version'.
	stream nextPutAll: selectorName.
	stream nextPutAll: ': spec 
        <version: '''.
	stream nextPutAll: newVersionNumber.
	stream nextPutAll: ''' imports: #(''', self lastBaseLine,''')>

        spec for: #common do: [
                spec blessing: ',blessingSelector printString,'.
'.

	self dependentPackages 
		do: [:pName | 
				stream nextPutAll: '			spec package: ''', pName, ''' with: '''.
							
				mcWorkingCopy := (MCPackage named: pName) workingCopy.
				mcWorkingCopy needsSaving ifTrue: [ self inform: 'The configuration you want to save depends on the package ', pName, '. You first need to save this package in order to create the version'. ^ self ].
				stream nextPutAll: (mcWorkingCopy ancestry ancestors first name).
			
				stream nextPutAll: '''.', String cr ].
	stream nextPutAll: '                ].'.

	self configurationClass compile: stream contents classified: 'versions'.

! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
dependentPackages
	"Return the list of dependent packages for the last baseline"

	"This method must be rewritten. It is a shame..."
	
	| lastBaseLineName lastBaseLineMethod versionConstructor versionSpec possiblePackageNames packageInfos packageNames |
	lastBaseLineName := self lastBaseLine.

	packageNames := OrderedCollection new.
	(self configurationClass project version: lastBaseLineName)
		record loadDirective packageDirectivesDo: [:directive |
			packageNames add: directive file ].
		
	^ packageNames collect: [:p | 
		(p includes: $.)
			ifTrue: [ (p includes: $-)
						ifTrue: [ (p copyUpToLast: $-) ]
						ifFalse: [ (p copyUpTo: $.) ] ]
			ifFalse: [ p ]
		]

"	lastBaseLineMethod := (self configurationClass methods 
							select: [:cm | cm selector beginsWith: 'baseline'])
								select: [:cm | cm pragmas first arguments first = lastBaseLineName].
	lastBaseLineMethod := lastBaseLineMethod first.
"	
	"This does not work!! No idea why!!"
"	versionConstructor := (Smalltalk at: #MetacelloVersionConstructor) new.
	self configurationClass new perform: lastBaseLineMethod selector with: versionConstructor.
	versionSpec := (Smalltalk at: #MetacelloVersionSpec) new.
	versionConstructor root: versionSpec
"
	"This is probably the ugliest piece of code I ever wrote. There is really nothing to be proud of."
"	possiblePackageNames := 
		((lastBaseLineMethod literals select: [ :l | l class == ByteString ])
			reject: [:l | l beginsWith: 'http']).
	packageInfos := PackageInfo allPackages select: [ :pi | possiblePackageNames includes: pi packageName ].
"
	"packageInfos now contains the package that the lastest baseline depends on"
	"^ packageInfos collect: #packageName"

	! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
hasAnyBaseline 
	^ self baseLines notEmpty! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
lastBaseLine
	^ self baseLines last! !

Object subclass: #NewVersionBrowser
	instanceVariableNames: 'list class selector browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-VersionBrowser'!

!NewVersionBrowser commentStamp: '<historical>' prior: 0!
A NewVersionBrowser is a tool made for browsing the several versions of the provided method.!

!NewVersionBrowser class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 09:56'!
browseVersionsOf: method class: class meta: meta category: msgCategory selector: selector 
	
	^ self new 
			browseVersionsOf: method 
			class: class 
			meta: meta 
			category: msgCategory 
			selector: selector! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:50'!
browseVersionsOf: method class: aClass meta: meta category: msgCategory selector: aSelector

	class := meta 
		ifTrue: [ aClass theMetaClass ]
		ifFalse: [ aClass  theNonMetaClass ].

	selector := aSelector.
	
	^ self buildBrowser! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/3/2012 13:55'!
browserForList: aList

	browser:=  MessageBrowser new.
	browser
		textConverter: DiffMethodReferenceConverter new;
		topologicSort: false;
		sortingBlock: [:a :b | a timeStamp > b timeStamp ];
		displayBlock: [:changeRecord | {	changeRecord stamp firstWord. 
											changeRecord timeStamp asString.
											changeRecord class name.
											changeRecord methodSelector.
											'{',changeRecord  category,'}'} ].
	browser toolbarModel setDropListItems: {	DropListItem named: 'Diff' do: [ browser textConverter: (DiffChangeRecordConverter methodReference: browser textConverter method referencesList: aList) ].
									DropListItem named: 'Source' do: [ browser textConverter: (SourceMethodConverter method: browser textConverter method) ]}.
									
	browser toolbarModel versionModel 
		label: 'Revert';
		action: [ self revert: browser selectedItem ].
										
	^ browser.! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:40'!
buildBrowser
	| changeList |
	
	changeList := self buildChangeList.
	self browserForList: changeList.
	
	^ browser
		messages: changeList;
		title: 'Versions of ' , class name , '>>' , selector;
		openWithSpec! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:50'!
buildChangeList
	| method |
	
	(class isNil or: [ selector isNil ])	ifTrue: [ ^ #() ].
	method := (class>>selector).
		
	^ self
		scanVersionsOf: method
		class: class theNonMetaClass
		meta: class isMeta
		category: method category
		selector: selector.! !

!NewVersionBrowser methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/14/2012 11:44'!
revert: aChangeRecord

	aChangeRecord 
		ifNil: [self inform: 'nothing selected, so nothing done']
		ifNotNil: [ class ifNotNil: [ class compile: aChangeRecord string ]].
	
	browser 
		messages: self buildChangeList;
		setSelectedIndex: 1.! !

!NewVersionBrowser methodsFor: 'copy and paste' stamp: 'BenjaminVanRyseghem 6/14/2012 10:00'!
scanVersionsOf: method class: class meta: meta category: cat selector: selector

	^ ChangeSet scanVersionsOf: method class: class meta: meta category: cat selector: selector! !

ComposableModel subclass: #AbstractApiSetter
	instanceVariableNames: 'choice method model selector retrievingMethod isSetting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!AbstractApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
choice
	^ choice! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:46'!
initialExtent 

	^ 450@25! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:35'!
initialize
	"Initialization code for BooleanApiSetter"

	
	method := nil asValueHolder.
	model := nil asValueHolder.
	retrievingMethod := nil asValueHolder.
	isSetting := false.
	
	super initialize.
	self registerEvents! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		DropListModel ).
				
	self selector text: ''.
	self choice items: (#(true false) collect: [:b | DropListItem 
													named: b printString
													do: [ self setValueTo: b ]]).! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
internUpdateWith: aValue

	self subclassResponsibility! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 20:35'!
isSetting

	^ isSetting! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 20:35'!
isSetting: aBoolean 

	isSetting := aBoolean ! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
method

	^ method contents! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
method: anObject

	method contents: anObject! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
model

	^ model contents! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
model: anObject

	model contents: anObject! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 19:45'!
registerEvents

	self registerRetrievingMethodEvent.
	self registerModelEvent.
	self registerMethodEvents! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/13/2012 02:41'!
registerMethodEvents

	method whenChangedDo: [ :s | 
			selector text: s asString.
			self model ifNotNil: [ :m | choice help: (m class lookupSelector: s) comment ] ]! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
registerModelEvent

	model whenChangedDo: [ :m | 
			self retrievingMethod
				ifNotNil: [ :meth || value |
					value := m perform: meth.
					self internUpdateWith: value ]]! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
registerRetrievingMethodEvent

	retrievingMethod whenChangedDo: [ :meth | 
			self model
				ifNotNil: [ :m || value |
					value := m perform: meth.
					self internUpdateWith: value ]]! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
retrievingMethod

	^ retrievingMethod contents! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
retrievingMethod: anObject

	retrievingMethod contents: anObject! !

!AbstractApiSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 17:50'!
selector
	^ selector! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 19:25'!
selectorWidth: aNumber
	| layout |
	layout := SpecLayout composed 
				newRow: [:r | 
					r 
						newColumn: [:c | c add: #selector ] width: aNumber;
						add: #choice ]
				height: 25;
				yourself.
				
	self needRebuild: false.
	selector needRebuild: false.
	choice needRebuild: false.
	
	self buildWithSpecLayout: layout.! !

!AbstractApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:41'!
setValueTo: anObject

	self model ifNil: [ ^ self ].
	self method ifNil: [ ^ self ].
	
	self isSetting ifFalse: [ 
		self isSetting: true.
		self model perform: (self method) with: anObject.
		self isSetting: false ].! !

!AbstractApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:59'!
updateWith: aValue

	self isSetting ifFalse: [ 
		self isSetting: true.
		self internUpdateWith: aValue.
		self isSetting: false ]! !

AbstractApiSetter subclass: #BlockApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!BlockApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 19:00'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!BlockApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 19:11'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		BlocEditor ).
				
	self selector text: ''.
	self choice whenBlockChangedDo: [:b | self setValueTo: b ]! !

!BlockApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:45'!
internUpdateWith: value
	| string idx start end pre body |
	
	string := value printString.
	idx := string indexOf: $|.
	idx isZero
		ifTrue: [ 
			pre := '['.
			idx := idx +1 ]
		ifFalse: [ pre := (string copyFrom: 1 to: idx), ' ' ].
	start := idx + 1.
	end := string size-1.
	body := (string copyFrom: start to: end) trimBoth.

	choice pre text: pre.
	choice text text: body! !

AbstractApiSetter subclass: #BooleanApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!BooleanApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 17:30'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!BooleanApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/13/2012 02:12'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		CheckBoxModel ).
				
	self selector text: ''.
	self choice 
		label: 'true/false';
		labelClickable: true;
		whenChangedDo: [:b | self setValueTo: b ];
		state: false.! !

!BooleanApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 22:25'!
internUpdateWith: value

	choice state: value! !

AbstractApiSetter subclass: #ColorApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!ColorApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/16/2012 19:24'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!ColorApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/16/2012 19:29'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		ColorEditor ).
				
	self selector text: ''.
	self choice whenColorChangedDo: [:c | self setValueTo: c ]! !

!ColorApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:26'!
internUpdateWith: aColor

	choice setAbsoluteRed: aColor red.
	choice setAbsoluteBlue: aColor blue.
	choice setAbsoluteGreen: aColor green.
	choice setAbsoluteAlpha: aColor alpha.! !

AbstractApiSetter subclass: #IntegerApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!IntegerApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/12/2012 19:44'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!IntegerApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 20:01'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		IntegerEditor ).
				
	self selector text: ''.
	self choice whenIntegerChangedDo: [:b | self setValueTo: b ]! !

!IntegerApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:58'!
internUpdateWith: value

	choice value: value ! !

!IntegerApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/13/2012 02:55'!
registerMethodEvents

	method whenChangedDo: [ :s |
			selector text: s asString.
			self model ifNotNil: [ :m || mth |
				mth := (m class lookupSelector: s).
				self updateSliderWith: mth.
				choice help: mth comment ]]! !

!IntegerApiSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/13/2012 04:30'!
updateSliderWith: aMethod
	| prg min max old | 
	
	prg := aMethod pragmas detect: [:e | e keyword beginsWith: 'api:' ] ifNone: [ ^ self ].
	min := prg arguments second.
	max := prg arguments third.
	"
	
	old := self model perform: prg arguments fourth."
	
	max isInteger
		ifTrue: [ choice max: max ]
		ifFalse: [ choice max: (self model perform: max) ].
	min isInteger
		ifTrue: [ choice min: min ]
		ifFalse: [ choice min: (self model perform: min) ].
		
	"self isSetting ifFalse:[
		self isSetting: true.
		choice value: old.
		self isSetting: false ]"! !

AbstractApiSetter subclass: #StApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!StApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/12/2012 18:16'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					newColumn: [:c | c add: #choice ] width: 75]
			height: 25;
			yourself! !

!StApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 18:22'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		STEditor ).
				
	self selector text: ''.
	self choice whenObjectChangedDo: [:b | self setValueTo: b ]! !

!StApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
internUpdateWith: value
	
	choice text text: "value storeString"''! !

AbstractApiSetter subclass: #StringApiSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!StringApiSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 17:45'!
spec
	<spec>
	
	^ SpecLayout composed 
			newRow: [:r |
				r 
					add: #selector;
					add: #choice ]
			height: 25;
			yourself! !

!StringApiSetter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 17:44'!
initializeWidgets 
	
	self instantiateModels: #(
		selector 	LabelModel 
		choice 		TextInputFieldModel  ).
				
	self selector text: ''.
	self choice
			autoAccept: true;
			entryCompletion: nil;
			ghostText: 'new value';
			acceptBlock: [:t | self setValueTo: t ].! !

!StringApiSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 20:34'!
internUpdateWith: value

	choice text: value asString! !

ComposableModel subclass: #BlocEditor
	instanceVariableNames: 'block ok post pre text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:17'!
block

	^ block contents! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:17'!
block: aBlock

	block contents: aBlock ! !

!BlocEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 18:05'!
buildWithSpec

	^ self buildWithSpecLayout: self layout! !

!BlocEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 18:09'!
buildWithSpec: aSpec

	^ self buildWithSpecLayout: self layout! !

!BlocEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:00'!
help: aString 
	
	text help: aString ! !

!BlocEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/11/2012 18:18'!
initialize
	"Initialization code for BlocEditor"

	super initialize.

	block := nil asValueHolder! !

!BlocEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/12/2012 18:25'!
initializeWidgets 

	self  instantiateModels: #( 
		pre 	LabelModel 
		post 	LabelModel 
		text 	TextInputFieldModel
		ok 		ButtonModel ).
			
	pre text: '['.
	post text: ']'.
	text
		autoAccept: false;
		entryCompletion: nil;
		acceptBlock: [ self okAction ];
		ghostText: 'body'.
		
	ok 
		label: 'ok';
		state: false;
		enabled: true;
		action: [ self okAction ].
		
	self focusOrder 
		add: text;
		add: ok! !

!BlocEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 18:58'!
layout
	| width width2 |
	width := StandardFonts defaultFont widthOfStringOrText: pre getText.
	width2 := StandardFonts defaultFont widthOfStringOrText: post getText.
	^ SpecLayout composed 
		newRow: [:r |
			r
				newColumn: [:c | c add: #pre ] width: width;
				add: #text;
				newColumn: [:c | c add: #post ] width: width2;
				newColumn: [:c | c add: #ok ] width: 25 ]
		 height: 25;
		yourself! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
ok

	^ ok! !

!BlocEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 18:20'!
okAction

	text accept.
	block contents: (Compiler evaluate: (String streamContents: [:s | s << '[' << text getText <<']'])).! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:08'!
post
	^ post! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 18:08'!
pre
	^ pre! !

!BlocEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
text
	^ text! !

!BlocEditor methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/11/2012 19:11'!
whenBlockChangedDo: aBlock

	block whenChangedDo: aBlock ! !

ComposableModel subclass: #ChangeSorterApplication
	instanceVariableNames: 'model changesListModel classesListModel methodsListModel textModel prettyPrint showDiff title prettyButton diffButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterApplication commentStamp: '<historical>' prior: 0!
A ChangeSorterApplication is spec version of the dual sorter!

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/31/2012 16:09'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		newColumn: [:c | 
				c 
					newRow: [:r | r 
									add: #changesListModel;
									addSplitter;
									add: #classesListModel ];
					addSplitter;
					add: #methodsListModel;
					addSplitter;
					add: #textModel ].! !

!ChangeSorterApplication class methodsFor: 'tools-registry' stamp: 'StephaneDucasse 7/4/2012 19:48'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry register: self as: #changeSorter! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
addPreamble

	self model addPreambleTo: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
browseChangeSet
	"Open a message list browser on methods in the current change set"

	| messages |
	messages := self selectedChangeSet changedMessageList select: [ :each | each isValid].	
	Smalltalk tools  messageList
		openMessageList: messages 
		name: 'Methods in Change Set ', self selectedChangeSet name 
		autoSelect: ''! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseImplementorsOfMessages

	self model browseMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseMethodFull
	"Create and schedule a full Browser and then select the current class and message."

	self selectedClass ifNotNil:
		[:myClass | Smalltalk tools browser fullOnClass: myClass selector: self selectedSelector ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseSendersOfMessages

	self model browseSendersOfMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseVersions
	"Create and schedule a changelist browser on the versions of the 
	selected message."
	
	self selectedClass ifNotNil: [:class |
		self selectedSelector ifNotNil: [:selector || method |
			method := class methodDict 
								at: selector 
								ifAbsent: [ ^ self inform: 'Sorry, only actual methods have retrievable versions.' ].
			self model browseVersionsFrom: method ]]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu1: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	aMenu 
		title: 'Change Set';
		target: self.
		
	self selectedChangeSet
		ifNotNil:[
			aMenu
				add: 'Make changes go to me (m)'
				action: #setCurrentChangeSet;
				addLine;
				add: 'New change set... (n)'
				action: #newSet ].
	aMenu
		add: 'Find...(f)' 
		action: #findChangeSet.

	self selectedChangeSet
		ifNotNil:[
			aMenu
				addLine;
				add: 'Rename change set (r)'
				action: #rename;
				add: 'File out (o)'
				action: #fileOut;
				add: 'Browse methods (b)' 
				action: #browseChangeSet;
				add: 'Browse change set (B)'
				action: #openChangeSetBrowser;
				addLine ]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu2: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	| cs |
	
	cs := self selectedChangeSet.
	self selectedChangeSet
		ifNotNil:[
			(cs notNil and: [ cs hasPreamble ])
				ifTrue: [
							aMenu add: 'Edit preamble (p)' action: #addPreamble.
							aMenu add: 'Remove preamble' action: #removePreamble	]
				ifFalse: [	aMenu add: 'Add preamble (p)' action: #addPreamble			].
			(cs notNil and: [ cs hasPostscript ])
				ifTrue: [	
							aMenu add: 'Edit postscript...' action: #editPostscript.
							aMenu add: 'Remove postscript' action: #removePostscript	]
				ifFalse: [	aMenu add: 'Add postscript...' action: #editPostscript			].

			aMenu addLine.

			aMenu add: 'Destroy change set (x)' action: #remove ].! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	isShifted ifTrue: [^ self shiftedChangeSetMenu: aMenu].
	self changeSetMenu1: aMenu shifted: isShifted.
	self changeSetMenu2: aMenu shifted: isShifted.
	
	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
changeSetShortcuts: event from: aMorph

	self selectedChangeSet
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseChangeSet ].
			event keyString = '<Cmd-B>' 		ifTrue: [ ^ self openChangeSetBrowser ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self setCurrentChangeSet ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self newSet ].
			event keyString = '<Cmd-o>' 		ifTrue: [ ^ self fileOut ].
			event keyString = '<Cmd-r>' 		ifTrue: [ ^ self rename ].
			event keyString = '<Cmd-p>' 		ifTrue: [ ^ self addPreamble ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self remove ]].
			
	event keyString = '<Cmd-f>' 				ifTrue: [ ^ self findChangeSet ].
		! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changeSets

	^ self changesListModel getList! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changesListModel

	^ changesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changesMenu: aBlock

	changesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changesShortcuts: aBlock

	changesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
classMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	self selectedClass ifNil: [ ^ nil ].
	aMenu title: 'Class list'.

	aMenu target: self.
	aMenu addList: #(
			-
			('Delete class from change set (d)'		forgetClass)
			('Remove class from system (x)'		removeClass)
			-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutClass)).

	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
classShortcuts: event from: aMorph

	self selectedClass
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetClass ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeClass ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
classesListModel

	^ classesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
classesMenu: aBlock

	classesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
classesShortcuts: aBlock

	classesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
currentText

	 ^ textModel getText! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
defaultTitle
	
	^  'Change Sorter'! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
editPostscript
	
	self selectedChangeSet editPostscript! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
fileOut

	self selectedChangeSet fileOut! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
fileOutClass

	self model fileOutClass: self selectedClass from: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
fileOutMessage
	"Put a description of the selected message on a file"

	self selectedSelector ifNotNil: [:selector |
		Cursor write showWhile:
			[ self model fileOutSelector: selector from: self selectedClass ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
findChangeSet

	| set |
	set := self model findChangeSetIn: self changeSets.
	changesListModel setSelectedItem: set.! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
forceChangesListRefresh
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
forgetClass
	"Remove all mention of this class from the changeSet"

	self okToChange ifFalse: [^ self].
	self selectedClass ifNotNil: [:class |
		self model removeClass: class from: self selectedChangeSet.
		self setSelectedChangeSet: self selectedChangeSet ].
! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
forgetMessage

	self okToChange ifFalse: [^ self].
	self selectedSelector ifNotNil: [:selector | 
		self model 
			forgetSelector: selector 
			inClass: self selectedClass 
			fromChangeSet: self selectedChangeSet.
		self updateClassesList.
		self setSelectedClassIndex: self selectedClassIndex ]! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 11:54'!
initialize
	"Initialization code for ChangeSorterApplication"

	prettyPrint := false.
	showDiff := false.
	
	model := ChangeSorterModel new.
	title := self defaultTitle.
	
	super initialize.
	self bindings: MorphicBindingsWithSplitters new.	
	
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:22'!
initializePresenter

	prettyButton activationAction: [ 
		prettyPrint := true.
		self updateTextContents ].
	prettyButton desactivationAction: [ 
		prettyPrint := false.
		self updateTextContents  ].
	diffButton activationAction: [ 
		showDiff := true.
		self updateTextContents ].
	diffButton desactivationAction: [ 
		showDiff := false.
		self updateTextContents  ].
	self registerChangeActions.
	self registerClassActions.
	self registerSelectorActions.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 11:52'!
initializeWidgets

	self instantiateModels: #(
		methodsListModel ListComposableModel
		classesListModel ListComposableModel
		changesListModel ListComposableModel
		prettyButton CheckBoxModel
		diffButton CheckBoxModel
		textModel TextModel ).
	
	self setFocus.
	
	methodsListModel menu: [:menu :shifted | self messageMenu: menu shifted: shifted ].
	methodsListModel shortcuts: [:event :source | self methodShortcuts: event from: source ].
	changesListModel menu: [:aMenu :shifted | self changeSetMenu: aMenu shifted: shifted  ].
	changesListModel shortcuts: [:event :source | self changeSetShortcuts: event from: source ].	
	classesListModel menu: [:aMenu :shifted | self classMenu: aMenu shifted: shifted ].
	classesListModel shortcuts: [:event :source | self classShortcuts: event from: source ].

	changesListModel items: self model allChanges.
	changesListModel displayBlock: [:item | item name ].
	textModel aboutToStyle: true.
	! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
messageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	self selectedSelector ifNil: [ ^ nil ].	
	aMenu title: 'Message list'.
	aMenu target: self.

	aMenu addList: #(
			('Delete method from changeSet (d)'	forgetMessage)
			('Remove method from system (x)'		removeMessage)
				-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutMessage)
			-
			('Senders of... (n)'						browseSendersOfMessages)
			('Implementors of... (m)'				browseImplementorsOfMessages)
			('Versions (v)'							browseVersions)).
	^ aMenu
! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
methodShortcuts: event from: aMorph

	self selectedSelector
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetMessage ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self browseImplementorsOfMessages ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self browseSendersOfMessages ].
			event keyString = '<Cmd-v>' 		ifTrue: [ ^ self browseVersions ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeMessage ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
methodsListModel

	^ methodsListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
methodsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
methodsShortcuts: aBlock

	methodsListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
newSet

	| aSet |
	self okToChange ifFalse: [ ^ self ].
	aSet := self model createNewSet.
	aSet ifNotNil:
		[	self updateChangesList.
			changesListModel setSelectedItem: aSet ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
openChangeSetBrowser
	| cs env |
	
	cs := self selectedChangeSet.
	cs ifNil: [ ^ nil ].
	
	env := RBBrowserEnvironment new forClasses: cs changedClasses.

	Smalltalk tools browser fullOnEnvironment: env! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
registerChangeActions
	
	changesListModel
		whenSelectedItemChanged: [:change | 
			classesListModel resetSelection.
			self updateTextContents.
			change 
				ifNil: [
					classesListModel items: {}.
					methodsListModel items: {}.
					self title: self defaultTitle ]
				ifNotNil: [
					classesListModel items: (change changedClasses sort: [:a :b | a name < b name ]).
					self title: change name ]].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
registerClassActions
	
	classesListModel whenSelectedItemChanged: [:class | 
		methodsListModel resetSelection.
		self updateTextContents.
		textModel behavior: class.
		textModel aboutToStyle: false.
		class 
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [ methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort ]].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
registerSelectorActions

	methodsListModel whenSelectedItemChanged: [:selector |
		self updateTextContents ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
remove
	"Completely destroy my change set.  Check if it's OK first"

	self okToChange ifFalse: [^ self].
	self model removeChangeSet: self selectedChangeSet prompting: true.
	self updateChangesList.
	changesListModel resetSelection! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
removeClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	(self model removeClass: self selectedClass)
		ifTrue: [ self setSelectedChangeSet: self selectedChangeSet ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
removeMessage
	"Remove the selected message from the system."
	
	self okToChange
		ifFalse: [^ self].
	self selectedSelector
		ifNotNil: [:selector |
				(self model removeMethod: selector inClass: self selectedClass)
					ifTrue: [ self updateMessagesList ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
removePostscript

	self model removePostscriptFrom: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
removePreamble

	self selectedChangeSet removePreamble.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
rename

	| set |
	set := self model rename: self selectedChangeSet.
	
	changesListModel 
		updateList;
		setSelectedItem: set! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedChangeSet

	 ^ changesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedChangeSetIndex

	 ^ changesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedClass

	 ^ classesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedClassIndex

	 ^ classesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedSelector

	 ^ methodsListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectorsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
setCurrentChangeSet

	self model setCurrentChangeSet: self selectedChangeSet.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
setFocus

	self focusOrder
		add: changesListModel;
		add: classesListModel;
		add: methodsListModel;
		add: textModel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedChangeSet: aChangeSet

	 ^ changesListModel setSelectedItem: aChangeSet! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedChangeSetIndex: anIndex

	 ^ changesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedClass: aClass

	 ^ classesListModel setSelectedItem: aClass! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedClassIndex: anIndex

	 ^ classesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
textModel

	^ textModel! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
title

	^ title! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 18:14'!
title: aTitle

	title := aTitle.
	self updateTitle! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateChangesList
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateClassesList
	| sel |
	sel := self selectedClass.
	
	self selectedChangeSet
			ifNil: [ classesListModel items: {} ]
			ifNotNil: [:change |	classesListModel items: (change changedClasses sort: [:a :b | a name < b name ])].
				
	classesListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateClassesListAndMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self updateClassesList.
	methodsListModel setSelectedItem: sel.
	self updateMessagesList.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self selectedClass
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [:class | methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort].
				
	methodsListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
updateTextContents

	| text |
	text :=  (self model 
				setContentsOfChangeSet: self selectedChangeSet
				forClass: self selectedClass
				andSelector: self selectedSelector
				prettyPrint: prettyPrint
				showDiff: showDiff).
	({'Method was added, but cannot be found!!'. 'Added then removed (see versions)'. 'Method has been removed (see versions)'} includes: text)
		ifTrue: [ textModel aboutToStyle: false ]
		ifFalse: [ textModel aboutToStyle: true ] .
	textModel text: text.! !

!ChangeSorterApplication methodsFor: 'protocol-events' stamp: 'StephaneDucasse 5/17/2012 19:31'!
whenChangesListChanges: aBlock

	changesListModel whenListChanged: aBlock! !

ComposableModel subclass: #ColorEditor
	instanceVariableNames: 'a b color g morph r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!ColorEditor class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/16/2012 19:19'!
spec
	<spec>
	
	^ SpecLayout composed
			newRow: [:r |
				r 
					add: #r;
					add: #g;
					add: #b;
					add: #a;
					newColumn: [:c | c add: #morph ] width: 25 ]
			 height: 25;
			yourself! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
a
	^ a! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
b
	^ b! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:05'!
color
	^ color contents! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:06'!
color: anObject
	color contents: anObject! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
g
	^ g! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:19'!
help: aString 
	
	r help: aString.
	g help: aString.
	b help: aString.
	a help: aString.! !

!ColorEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/16/2012 19:15'!
initialize
	"Initialization code for ColorEditor"

	super initialize.

	color := Color black asValueHolder.
	morph := Morph new 
				color: self color;
				extent: 25@25;
				yourself! !

!ColorEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/18/2012 16:48'!
initializeWidgets 

	self instantiateModels: #(
		r 	SliderModel
		g 	SliderModel
		b 	SliderModel
		a 	SliderModel ).
					
	r 
		min: 0;
		max: 255;
		label: 'red';
		quantum: 1;
		value: 0;
		whenValueChangedDo: [ self updateColor ].

	g 
		min: 0;
		max: 255;
		label: 'green';
		quantum: 1;
		value: 0;
		whenValueChangedDo: [ self updateColor ].

	b 
		min: 0;
		max: 255;
		label: 'blue';
		quantum: 1;
		value: 0;
		whenValueChangedDo: [ self updateColor ].

	a 
		min: 0;
		max: 255;
		label: 'alpha';
		quantum: 1;
		value: 255;
		whenValueChangedDo: [ self updateColor ].

	! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:06'!
morph
	^ morph! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:05'!
morph: anObject
	morph := anObject! !

!ColorEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/16/2012 19:18'!
r
	^ r! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteAlpha: aFloat

	a absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteBlue: aFloat

	b absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteGreen: aFloat

	g absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 19:27'!
setAbsoluteRed: aFloat

	r absoluteValue: aFloat ! !

!ColorEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/18/2012 16:54'!
updateColor
	| newColor |
	
	newColor := TranslucentColor r: r value g: g value b: b value range: 256.
	newColor := newColor alpha: (a value) / 256.
	r color: (Color r: r value g: 0 b: 0 range: 256).
	g color: (Color r: 0 g: g value b: 0 range: 256).
	b color: (Color r: 0 g: 0 b: b value range: 256).
	self color: newColor.
	morph color: newColor! !

!ColorEditor methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/16/2012 19:08'!
whenColorChangedDo: aBlock

	color whenChangedDo: aBlock ! !

!ComposableModel methodsFor: '*Spec-Tools-Editor' stamp: 'BenjaminVanRyseghem 7/11/2012 17:41'!
edit

	WidgetSetter new
		model: self;
		openWithSpec.! !

ComposableModel subclass: #DualChangeSorterApplication
	instanceVariableNames: 'model changeSorterLeft changeSorterRight isRefreshing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!DualChangeSorterApplication commentStamp: '<historical>' prior: 0!
A DualChangeSorterApplication is a dual change sorter based on psec!

!DualChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/31/2012 16:16'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
			newRow: [:r |
					r 
						add: #changeSorterLeft;
						addSplitter;
						add: #changeSorterRight ]! !

!DualChangeSorterApplication class methodsFor: 'menu' stamp: 'StephaneDucasse 7/4/2012 19:57'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder group: #SystemChanges)
		parent: #Tools;  
		with: [
			(aBuilder item: #'Change Sorter (Spec)')
				action:[self new openWithSpec]; 
				icon: self taskbarIcon.
			(aBuilder item: #'Recover lost changes...') 
				action: [Smalltalk tools changeList browseRecentLog]]! !

!DualChangeSorterApplication class methodsFor: 'tools-registry' stamp: 'StephaneDucasse 7/4/2012 19:48'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry register: self as: #dualChangeSorter! !

!DualChangeSorterApplication class methodsFor: 'specs' stamp: ''!
title

	^'Dual Change Sorter'! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 6/13/2012 12:00'!
changeSet: src to: dest shortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllFrom: src to: dest ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractFrom: src to: dest ].
	
	^ src changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changeSorterLeft

	^ changeSorterLeft! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changeSorterRight

	^ changeSorterRight! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 6/13/2012 12:25'!
changesMenu: menu shifted: shifted from: src to: dest

	src changeSetMenu1: menu shifted: shifted.
	
	src selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to the other change set (c)' 
				target: self
				selector: #copyAllFrom:to:
				argumentList: {src.dest}.
			menu 
				add: 'Submerge into the other change set' 
				target: self
				selector: #submerge:into:
				argumentList: {src.dest}.
			menu 
				add: 'Subtract the other change set (-)'
				target: self
				selector: #subtractFrom:to:
				argumentList: {src.dest}.
			menu addLine] .
	
	src changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
checkThatSidesDiffer: escapeBlock
	"If the change sets on both sides of the dual sorter are the same, put up an error message and escape via escapeBlock, else proceed happily"

	changeSorterLeft selectedChangeSet == changeSorterRight selectedChangeSet
		ifTrue:
			[self inform: 
'This command requires that the
change sets selected on the two
sides of the change sorter *not*
be the same.'.
			^ escapeBlock value]
! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'tbn 7/5/2012 14:14'!
classMenu: aMenu shifted: shifted from: src to: dest
	"Fill aMenu with items appropriate for the class list"

	src selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu
			add: 'Copy class to the other change set(c)' 
			target: self
			selector: #copyClassFrom:to:
			argumentList: {src.dest}.
	aMenu
			add: 'Move class to the other change set' 
			target: self
			selector: #moveClassFrom:to:
			argumentList: {src.dest}.
	aMenu addLine.
						
	src classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 6/13/2012 11:58'!
copyAllFrom: src to: dest

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (src selectedChangeSet) to: (dest selectedChangeSet).
	dest updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 6/13/2012 12:13'!
copyClassFrom: src to: dest
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	src selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := dest selectedChangeSet.
	
	self model copyClass: src selectedClass from: src selectedChangeSet to: otherChangeSet.
	
	dest setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 6/13/2012 12:18'!
copyMethodFrom: src to: dest
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := dest selectedChangeSet.
	
	src selectedSelector ifNotNil: [:selector || class |
		class := src selectedClass.
		
		self model 
			copySelector: selector 
			inClass: class 
			from: src selectedChangeSet 
			to: other.
			
		dest updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/31/2012 16:17'!
initialExtent

	^  900@530! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:12'!
initialize
	"Initialization code for DualChangeSorterApplication"

	super initialize.

	model := ChangeSorterModel new.
	isRefreshing := false.
	
	self bindings: MorphicBindingsWithSplitters new.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:32'!
initializePresenter

	changeSorterLeft 	whenChangesListChanges: [ self refeshedChangeSet: changeSorterRight ].
	changeSorterRight	whenChangesListChanges: [ self refeshedChangeSet: changeSorterLeft ].
! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:22'!
initializeWidgets
	"Initialization code for DualChangeSorterApplication"

	self instantiateModels: #(
		changeSorterLeft  ChangeSorterApplication
		changeSorterRight  ChangeSorterApplication ).
		
	self menusRegistration.
	self shortcutsRegistration.
	self setFocusOrder! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:30'!
menusRegistration

	self menusRegistrationFrom: changeSorterLeft to: changeSorterRight.
	self menusRegistrationFrom: changeSorterRight to: changeSorterLeft! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 6/13/2012 12:29'!
menusRegistrationFrom: src to: dest
	
	src changesMenu: [:menu :shifted | self changesMenu: menu shifted: shifted from: src to: dest ].
	src classesMenu: [:menu :shifted | self classMenu: menu shifted: shifted from: src to: dest ].
	src methodsMenu: [:menu :shifted | self messageMenu: menu shifted: shifted from: src to: dest ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'SeanDeNigris 7/16/2012 07:50'!
messageMenu: aMenu shifted: shifted from: src to: dest
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	src selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu
			add: 'Copy method to the other change set'
			target: self
			selector: #copyMethodFrom:to:
			argumentList: {src.dest}.
	aMenu
			add: 'Move method to the other change set' 
			target: self
			selector: #moveMethodFrom:to:
			argumentList: {src.dest}.
	aMenu addLine.
					
	src messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 6/13/2012 12:14'!
moveClassFrom: src to: dest

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ src selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassFrom: src to: dest.
	src forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 6/13/2012 12:19'!
moveMethodFrom: src to: dest

	self copyMethodFrom: src to: dest.
	src forgetMessage.
	src updateClassesListAndMessagesList.! !

!DualChangeSorterApplication methodsFor: 'event' stamp: 'BenjaminVanRyseghem 6/13/2012 12:31'!
refeshedChangeSet: changeSet

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSet updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: changeSorterLeft;
		add: changeSorterRight.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:05'!
shortcutsRegistration

	self shortcutsRegistrationFrom: changeSorterLeft to: changeSorterRight.
	self shortcutsRegistrationFrom: changeSorterRight to: changeSorterLeft.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 12:03'!
shortcutsRegistrationFrom: src to: dest
	
	src changesShortcuts: [:event :source | self changeSet: src to: dest shortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 6/13/2012 12:10'!
submergeFrom: src into: dest
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| source destination index |

	source := src selectedChangeSet.
	destination := dest selectedChangeSet.
	index := src selectedChangeSetIndex.

	(self model submerge: source into: destination) ifFalse: [ ^ self ].
	
	src updateChangesList.
	src setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 6/13/2012 12:01'!
subtractFrom: src to: dest
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := src selectedChangeSet.
	destination := dest selectedChangeSet.
	
	self checkThatSidesDiffer: [^ self].
	
	self model substractFrom: source to: destination.
	
	changeSorterRight setSelectedChangeSet: source.! !

ComposableModel subclass: #IntegerEditor
	instanceVariableNames: 'integer slider text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
buildWithSpec

	^ self buildWithSpecLayout: self layout! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
buildWithSpec: aSpec

	^ self buildWithSpecLayout: self layout! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
help: aString 
	
	slider help: aString ! !

!IntegerEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 19:36'!
initialize
	"Initialization code for BlocEditor"

	super initialize.

	integer := 0 asValueHolder! !

!IntegerEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/13/2012 05:34'!
initializeWidgets 

	self  instantiateModels: #( 
		slider 	SliderModel
		text 	LabelModel ).
			
	text 
		borderWidth: 4;
		borderColor: Color black;
		text: '0'.
	slider 
		quantum: 1;
		whenValueChangedDo: [:v | 
			integer contents: v.
			text text: v asString ].
			
	self focusOrder 
		add: slider;
		add: text! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
integer

	^ integer contents! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
integer: aBlock

	integer contents: aBlock ! !

!IntegerEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 19:40'!
layout
	| width |
	width := StandardFonts defaultFont widthOfStringOrText: (slider max + slider quantum) asString.
	
	^ SpecLayout composed 
		newRow: [:r |
			r
				add: #slider;
				newColumn: [:c | c add: #text ] width: width ]
		 height: 25;
		yourself! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
max: aNumber

	slider max: aNumber! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:52'!
min: aNumber

	slider min: aNumber! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:34'!
slider
	^ slider! !

!IntegerEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 19:33'!
text
	^ text! !

!IntegerEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
value: aNumber

	slider value: aNumber! !

!IntegerEditor methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 7/12/2012 19:38'!
whenIntegerChangedDo: aBlock

	integer whenChangedDo: aBlock ! !

ComposableModel subclass: #MessageBrowser
	instanceVariableNames: 'listModel textModel toolbarModel maxClassSize refreshingBlockHolder cachedHierarchy wrapper searchedStringHolder titleHolder model topologicSortHolder textConverterHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!MessageBrowser commentStamp: '<historical>' prior: 0!
A MessageBrowser is a UI to browse a list of method, regardless of what they could be.

example: 

MessageBrowser new
	openWithSpec;
	messages: (SystemNavigation new allSendersOf: #at:)
	yourself!

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseImplementors: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForImplementorsOf: aSymbol;
		messages: aCollection;
		title: aName;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseMessages: aCollection refreshingBlock: aBlock named: anObject

	^ self new
		refreshingBlock: aBlock;
		messages: aCollection;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseSenders: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForSendersOf: aSymbol;
		messages: aCollection;
		title: aName;
		autoSelect: aSymbol;
		yourself! !

!MessageBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/18/2012 06:09'!
defaultSpec
	<spec>
	| delta |
	delta := 13.
	^ SpecLayout composed 
			add: #listModel origin: 0@0 corner: 1@0.5 offsetOrigin: 0@0 offsetCorner: 0@(delta negated);
			add: #toolbarModel origin: 0@0.5 corner: 1@0.5 offsetOrigin: 0@(delta negated) offsetCorner: 0@delta;
			add: #textModel origin: 0@0.5 corner: 1@1 offsetOrigin: 0@delta offsetCorner: 0@0;
			yourself! !

!MessageBrowser class methodsFor: 'messageList interface' stamp: 'BenjaminVanRyseghem 5/14/2012 02:00'!
on: aMessageList named: aString

	^ self new
		messages: aMessageList methodReferenceList;
		title: aString;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
on: aList named: aString autoSelect: aSelector

	^ self new
		messages: aList;
		title: aString;
		autoSelect: aSelector;
		yourself! !

!MessageBrowser class methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 10:51'!
openFullProtocolForClass: aClass
	"Open a browser on the methods understood by aClass including the methods from Object and ProtoObject"

	self new openFullProtocolForClass: aClass! !

!MessageBrowser class methodsFor: 'tool registration' stamp: ''!
openMessageList: messageList name: aString autoSelect: aSelector
	" Tool registry compitibility "

	| title |
	aString last = $]
			ifTrue: [ title := aString substrings allButLast joinUsing: ' ' ]
			ifFalse: [ title := aString ].
			
	(aString beginsWith: 'Senders')
		ifTrue: [ ^ (self browseSenders: messageList of: aSelector named: title) openWithSpec ].
	
	(aString beginsWith: 'Implementors')
		ifTrue: [ ^ (self browseImplementors: messageList of: aSelector named: title) openWithSpec ].
	
	^ (self on: messageList named: title autoSelect: aSelector) openWithSpec! !

!MessageBrowser class methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 10:38'!
openSubProtocolForClass: aClass
	"Open a browser on the methods understood by aClass excluding the methods from Object and ProtoObject"

	self new openSubProtocolForClass: aClass! !

!MessageBrowser class methodsFor: 'tool registration' stamp: 'EstebanLorenzano 5/11/2012 11:42'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry register: self as: #messageList! !

!MessageBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/31/2012 17:16'!
testSpec
	<spec: #default>
	
	^ SpecLayout composed
			newColumn: [:col |
				col 
					add: #listModel;
					addSplitter;
					add: #toolbarModel height: 25;
					add: #textModel ]
				! !

!MessageBrowser class methodsFor: 'specs' stamp: ''!
title

	^ 'Message Browser'! !

!MessageBrowser methodsFor: 'private' stamp: ''!
accept: text notifying: notifyer

	listModel selectedItem
		ifNotNil: [:message | message methodClass compile: text notifying: notifyer ]! !

!MessageBrowser methodsFor: 'text selection' stamp: ''!
autoSelect: aSelector

	textModel readSelectionBlock: [:text | self searchedString: aSelector in: text ]! !

!MessageBrowser methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/14/2012 10:12'!
buildHierarchyForMessages: messages
	| result classes |
	
	result := IdentityDictionary new.
	self topologicSort 
		ifFalse: [ 
			messages do: [:m | result at: m put: {} ].
			^ result ].
	
	classes := (messages collect: #methodClass) asSet.
	messages do: [:message || level class |
		class := message methodClass.
		level := OrderedCollection new.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level addFirst: superClass ]].
		level addLast: class.
		level addLast: message selector.
		result at: message put: level ].
	^ result! !

!MessageBrowser methodsFor: 'testing' stamp: ''!
cacheHierarchyForClasses: aCollection

	cachedHierarchy := self buildHierarchyForMessages: aCollection.! !

!MessageBrowser methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 10:46'!
collectMethodsFrom: aClass til: superClass
	| methods class |

	methods := OrderedCollection new.
	class := aClass.
	methods addAll: class methods.
	
	[ class superclass = superClass ]
		whileFalse: [ 
			class := class superclass.
			methods addAll: class methods ].
	^ methods	! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/13/2012 10:48'!
displayBlock: aBlock

	^ listModel displayBlock: aBlock! !

!MessageBrowser methodsFor: 'private' stamp: ''!
highlightSearchedString: string
	
	| searchedString interval firstIndex |
	searchedString := searchedStringHolder contents.
	searchedString ifNil: [ ^ 0 to: 0 ].

	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := string findString: searchedString.
					interval := firstIndex to: (firstIndex+searchedString size-1)]
				ifFalse: [| lastIndex |
					firstIndex := string findString: list first,':'.
					lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
					interval := firstIndex to: (lastIndex + list last size)]]
		ifFalse: [
			" unary selector "
			firstIndex := string findString: searchedString.
			interval := firstIndex to: (firstIndex+searchedString size-1)].
	^ interval! !

!MessageBrowser methodsFor: 'private' stamp: ''!
initialExtent

	^ (500 min: (World extent x)) @ (550 min: (World extent y))! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/14/2012 10:32'!
initialize
	"Initialization code for MessageBrowser"

	textConverterHolder := SourceMethodConverter new asValueHolder.
	model := AbstractTool new.
	maxClassSize = nil.
	searchedStringHolder := '' asValueHolder.
	titleHolder := super title asValueHolder.
	topologicSortHolder := true asValueHolder.
	super initialize.
	
	self registerToAnnouncements.
	self bindings: MorphicBindingsWithSplitters new.! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/20/2012 15:25'!
initializeDropList

	| item1 item2 item3 item4 |
	item1 := DropListItem 
					named: 'Source' 
					do: [ self textConverter: SourceMethodConverter new ].
	item2 := DropListItem 
					named: 'Byte Code' 
					do: [ self textConverter: ByteCodeMethodConverter new ].
	item3 := DropListItem
					named: 'Decompile' 
					do: [ self textConverter: DecompileMethodConverter new ].
	item4 := DropListItem
					named: 'Time stamp' 
					do: [ self textConverter: TimeStampMethodConverter new ].
	toolbarModel setDropListItems: {item1. item2. item3. item4}! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 15:32'!
initializePresenter

	listModel whenSelectedItemChanged: [:item |
			toolbarModel method: item.
			textModel behavior: (item ifNil: [ nil ] ifNotNil: [ item methodClass ]).
			textModel text: (self textConverter method: item; getText)].
		
	listModel whenListChanged: [ self updateTitle ].
		
	titleHolder whenChangedDo: [ self updateTitle ].
	textModel acceptBlock: [ :text :notifyer | self accept: text notifying: notifyer ].! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 17:57'!
initializeWidgets

	self instantiateModels: #(
		listModel 		MultiColumnListModel
		textModel 		TextModel
		toolbarModel 	MethodToolbar ).
	
	listModel displayBlock: [ :item | self wrapItem: item ].
	textModel aboutToStyle: true.
	refreshingBlockHolder := [ :item | false ] asValueHolder.
				
	self
		setListMenu;
		setListShortcuts;	
		initializeDropList;
		setFocus.
! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
listModel
	
	^ listModel! !

!MessageBrowser methodsFor: 'initialization' stamp: 'CamilloBruni 5/8/2012 02:08'!
listShortcutsFor: event form: source message: method

	event keyString = '<Cmd-b>'			ifTrue: [ ^ Smalltalk tools browser fullOnClass: method methodClass selector: method selector ].
	event keyString = '<Cmd-i>'			ifTrue: [ ^ method inspect ].
	event keyString = '<Cmd-x>'			ifTrue: [ ^ model removeMethod: method inClass: method methodClass ].
	event keyString = '<Cmd-n>'			ifTrue: [ ^ model browseSendersOfMessagesFrom: method selector ].
	event keyString = '<Cmd-m>'			ifTrue: [ ^ model browseMessagesFrom: method selector ].
	event keyString = '<Cmd-N>'			ifTrue: [ ^ model browseClassRefsOf: method methodClass ].
	event keyString = '<Cmd-v>'			ifTrue: [ ^ model browseVersionsFrom: method compiledMethod ].
	^ false! !

!MessageBrowser methodsFor: 'private' stamp: ''!
maxClassSize

	^ maxClassSize ifNil:[| elt stm |
			elt := (listModel getList detectMax: [:e | e methodClass name size + (cachedHierarchy at: e) size]).
			stm := String streamContents: [:t | 
				3 to: (cachedHierarchy at: elt) size do: [:i | t << '    '].
				t << elt methodClass name ].
			maxClassSize := StandardFonts listFont widthOfString: stm ].
! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:55'!
messages

	^ listModel listItems! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/7/2012 13:17'!
messages: aCollection

	self cacheHierarchyForClasses: aCollection.
	listModel items: (cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]) asOrderedCollection.
	listModel listSize > 1
		ifTrue: [ 
			listModel setSelectedIndex: 1 ].! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 6/12/2012 17:44'!
methodAdded: anAnnouncement
	| item |	
		
	self isDisplayed ifFalse: [ ^ self ].
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].
	
	WorldState addDeferredUIMessage: [ 	| sel text boolean |
		boolean := textModel hasUnacceptedEdits.
		boolean ifTrue: [ text := textModel pendingText ].
		sel := listModel selectedItem.
		self messages: (listModel listItems add: item; yourself).
		listModel setSelectedItem: sel.
		boolean ifTrue: [ textModel pendingText: text ]
	]! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 6/12/2012 17:47'!
methodModified: anAnnouncement
	| item oldItem sel index |
	
	self isDisplayed ifFalse: [ ^ self ].
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	oldItem := anAnnouncement oldItem.
	sel := listModel selectedItem.
	sel ifNil: [ ^ self ].
	(sel notNil and: [(sel methodClass = oldItem methodClass and: [ sel selector = oldItem selector ])]) ifFalse: [ ^ self ].
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].	
		index := listModel selectedIndex .
	WorldState addDeferredUIMessage: [	| text list edits |
		edits := textModel hasUnacceptedEdits.
		edits
			ifTrue: [ text := textModel pendingText ].
		list := listModel listItems 
				remove: sel ifAbsent: [];
				add: item asRingDefinition; "to ensure it's still as RGMethod"
				yourself. 
		self messages: list.
		listModel setSelectedIndex: index.
		edits
			ifTrue: [ 
				textModel pendingText: text.
				textModel hasEditingConflicts: true ].
		]! !

!MessageBrowser methodsFor: 'announcements' stamp: ''!
methodRecategorized: aMethod! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 6/12/2012 17:45'!
methodRemoved: anAnnouncement
	| item |

	self isDisplayed ifFalse: [ ^ self ].
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	"Item is a compiled methed, where the list is populated with RGMethod"
	
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self)
		ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	WorldState addDeferredUIMessage:[ 	|  sel itm hasPendingText |
		sel := listModel selectedIndex.
		itm := listModel selectedItem.
		hasPendingText := false.
		(itm notNil and: [(itm methodClass = item methodClass and: [ itm selector = item selector ])])
			ifTrue: [ textModel hasUnacceptedEdits: false ].
		self messages: (listModel listItems remove: item asRingDefinition ifAbsent: [ nil ]; yourself).
		listModel setSelectedIndex: sel.
	]! !

!MessageBrowser methodsFor: 'messageList interface' stamp: 'BenjaminVanRyseghem 5/14/2012 02:00'!
open

	self openWithSpec! !

!MessageBrowser methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 14:42'!
openFullProtocolForClass: aClass

	self messages: (self collectMethodsFrom: aClass til: nil).
	self title: 'Full protocol of ', aClass name.
	self openWithSpec.! !

!MessageBrowser methodsFor: 'protocolBrowser interface' stamp: 'BenjaminVanRyseghem 6/13/2012 14:42'!
openSubProtocolForClass: aClass

	self messages: (self collectMethodsFrom: aClass til: Object).
	self title: 'Sub protocol of ', aClass name.
	self openWithSpec.! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/10/2012 15:32'!
openWithSpec

	super openWithSpec.
	self updateTitle.
	textModel text: textModel getText.
	^ window! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
refreshingBlock: aBlock

	refreshingBlockHolder contents: aBlock! !

!MessageBrowser methodsFor: 'announcements-registration' stamp: ''!
registerToAnnouncements

	SystemAnnouncer announcer weak		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		on: MethodRecategorized send: #methodRecategorized: to: self;
		on: MethodRemoved send: #methodRemoved: to: self! !

!MessageBrowser methodsFor: 'text selection' stamp: ''!
searchedString: searchedString in: aString
	| string interval firstIndex |
	
	searchedString ifNil: [ ^ 0 to: 0 ].
	aString isEmptyOrNil ifTrue: [ ^0 to: 0 ].
	string := aString asString.
	interval := 0 to: 0.
	
	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: searchedString startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]]
				ifFalse: [| lastIndex |
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: list first,':' startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ 
									lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
									interval := firstIndex to: (lastIndex + list last size)]]]]
		ifFalse: [
			" unary selector "
			firstIndex := 1.
			[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
				whileTrue: [
					firstIndex := string findString: searchedString startingAt: firstIndex +1.
					firstIndex isZero
						ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]].
	^ interval! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 11:34'!
selectedItem

	^ listModel selectedItem! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
selectedMessage

	^ listModel selectedItem! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
selectedMessage: aMessage

	listModel setSelectedItem: aMessage.! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setFocus

	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setListMenu

	listModel menu: [:menu || message |
		message := self selectedMessage.
		menu
			add: 'Browse full... (b)'
			target: Smalltalk tools browser
			selector: #fullOnClass:selector:
			argumentList: {message methodClass. message selector };
			add: 'Inspect method... (i)'
			target: message
			selector: #inspect;
			addLine;
			add: 'Remove method... (x)'
			target: model
			selector: #removeMethod:inClass:
			argumentList: {message. message methodClass.};
			add: 'Toggle Breakpoint'
			target: model
			selector: #toggleBreakOnEntryIn:
			argument: message;
			addLine;
			add: 'Senders of... (n)'
			target: model
			selector: #browseSendersOfMessagesFrom:
			argument: message selector;
			add: 'Implementors of... (m)'
			target: model
			selector: #browseMessagesFrom:
			argument: message selector ;
			add: 'Users of... (N)'
			target: model
			selector: #browseClassRefsOf:
			argument: message methodClass;
			add: 'Versions... (v)'
			target: model
			selector: #browseVersionsFrom:
			argument: message.
		menu]! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setListShortcuts

	listModel shortcuts: [:event :source || message |
		message := self selectedMessage.
		self listShortcutsFor: event form: source message: message ]! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
setRefreshingBlockForImplementorsOf: aSelector

	self refreshingBlock: [:message | message selector = aSelector ].! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
setRefreshingBlockForSendersOf: aSelector
	| specialFlag specialByte |
	
	specialFlag := Smalltalk 
				hasSpecialSelector: aSelector
				ifTrueSetByte: [ :b | specialByte := b ].

	self refreshingBlock: [:method | (method refersToLiteral: aSelector) or: [ specialFlag and: [ method scanFor: specialByte ]]]! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 11:41'!
setSelectedIndex: anIndex

	listModel setSelectedIndex: anIndex ! !

!MessageBrowser methodsFor: 'testing' stamp: ''!
sortClassesInCachedHierarchy: a b: b
	"Bullshitty name, Thanks Camillo"
	| index aa bb minSize|
	aa := cachedHierarchy at: a.
	bb := cachedHierarchy at: b.
	
	minSize := aa size min: bb size.
	
	1 to: minSize do: [ :i | |compare|
		compare := (aa at: i) name compare: (bb at: i) name.
		compare ~~ 2
			ifTrue: [  ^ compare == 1 ]].
	^  aa size < bb size! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:15'!
sortingBlock: aBlock

	listModel sortingBlock: aBlock! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/14/2012 10:32'!
textConverter
	
	^ textConverterHolder contents! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/14/2012 10:32'!
textConverter: aTextConverter

	textConverterHolder contents: (aTextConverter method: self textConverter method).
	textModel aboutToStyle: self textConverter shouldShout .
	textModel text: self textConverter getText.! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
textModel
	
	^ textModel! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/10/2012 15:31'!
title
		
	^ titleHolder contents , ' [' , listModel listSize printString , ']'! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
title: aString

	titleHolder contents: aString.! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
toolbarModel
	
	^ toolbarModel! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:06'!
topologicSort
	
	^ topologicSortHolder contents! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/14/2012 10:07'!
topologicSort: aBoolean
	
	^ topologicSortHolder contents: aBoolean! !

!MessageBrowser methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 6/14/2012 11:47'!
whenSelectedItemChanged: aBlock 

	listModel whenSelectedItemChanged: aBlock ! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/18/2012 15:58'!
wrapItem: anItem
	| s |
	
	s :=String streamContents: [:t | 
		3 to: (cachedHierarchy at: anItem) size do: [:i | t << '    '].
		t << anItem methodClass name<< ' ('<< (anItem category ifNil: ['']) <<')'].
	
	^ {s. anItem selector}.! !

ComposableModel subclass: #MonticelloRepositoryBrowser
	instanceVariableNames: 'repositories workingCopies order'
	classVariableNames: 'Order'
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!MonticelloRepositoryBrowser commentStamp: '<historical>' prior: 0!
MonticelloRepositoryBrowser example!

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 20:29'!
allManagers 

	^ MCWorkingCopy allManagers ! !

!MonticelloRepositoryBrowser class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:51'!
defaultSpec

	^ {
		#ComposableSpec.
			#add: . {{#model . #workingCopies} . 
					#layout: . { #FrameLayout . #fractions:. 0@0 corner: 0.5@1.} 
					} . 
			#add: . {{#model . #repositories } . 
					#layout: . { #FrameLayout . #fractions:. 0.5@0 corner: 1@1.} 
					}
		}! !

!MonticelloRepositoryBrowser class methodsFor: 'example' stamp: 'StephaneDucasse 6/2/2012 20:29'!
example
	"self example"
	
	self new 
		openWithSpec ; 
		workingCopies: (self allManagers)! !

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 4/17/2012 18:41'!
order
	^ Order ifNil: [ Order := 1 ]! !

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 4/17/2012 18:42'!
order: anInteger
	Order := anInteger! !

!MonticelloRepositoryBrowser class methodsFor: 'spec' stamp: 'StephaneDucasse 4/17/2012 18:07'!
title

	^ 'Monticello Browser'! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 6/2/2012 20:29'!
allManagers

	^ self class allManagers 
	! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 18:31'!
allRepositories

	^ MCRepositoryGroup default repositories! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:20'!
browseWorkingCopy
	| workingCopy |
	workingCopy := self workingCopy.
	workingCopy
		ifNotNil: [ 
			(MCSnapshotBrowser forSnapshot: workingCopy completeSnapshot)
				label: 'Snapshot Browser: ' , workingCopy packageName;
				show ]! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 19:11'!
defaultOrderingBlock

	^ (self orderSpecs at: self class order) value! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'StephaneDucasse 4/17/2012 18:06'!
initialExtent

	^ 600@200! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:41'!
initialize
	"Initialization code for MonticelloRepositoryBrowser"

	super initialize.
	order := self class order! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:41'!
initializePresenter

	workingCopies whenSelectedItemChanged: 
			[ :item | repositories items: (self repositoriesOfWorkingCopy: item) ].! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:41'!
initializeWidgets

	self instantiateModels: #(
		repositories  ListComposableModel
		workingCopies  ListComposableModel).
		
	workingCopies sortingBlock: self defaultOrderingBlock.
	workingCopies displayBlock: [ :item | item description ].
	workingCopies menu: [ :aMenu | self workingCopiesMenu: aMenu ].
		
	repositories displayBlock: [ :item | item description ].
	repositories items: self allRepositories.

	"so that when we tab we go from working copies to repositories"
	self focusOrder
		add: workingCopies;
		add: repositories! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:21'!
newRepository
	| types index |
	types := MCRepository allConcreteSubclasses asArray.
	index := UIManager default chooseFrom: (types collect: [:ea | ea description])
				title: 'Repository type:'.
	^ index = 0 ifFalse: [(types at: index) morphicConfigure]! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:19'!
openRepository
	self repository ifNotNil: [:repos | repos morphicOpen: self workingCopy ]! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:49'!
order

	^ order! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'SD 4/19/2012 16:16'!
order: anInteger

	order := anInteger.
	self workingCopies sortingBlock: (self orderSpecs at: order) value.
	self order = 4 "dirty only"
		ifTrue: [self workingCopies filteringBlock: [:col | col select: #modified]]
		ifFalse: [self workingCopies resetFilteringBlock]. ! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:35'!
orderSpecs
	^ {
		'Sort alphabetically' -> [ :a :b | a package name <= b package name ].
		'Sort dirty first' -> [ :a :b | 
			a needsSaving = b needsSaving
				ifTrue: [ a package name <= b package name ]
				ifFalse: [ a needsSaving ] ].
		'Sort dirty last' -> [ :a :b | 
			a needsSaving = b needsSaving
				ifTrue: [ a package name <= b package name ]
				ifFalse: [ b needsSaving ] ].
		'Only dirty' -> [ :a :b | a package name <= b package name ]}! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:48'!
orderString: anIndex
	^ String streamContents: [ :stream |
		order = anIndex
			ifTrue: [ stream nextPutAll: '<yes>' ]
			ifFalse: [ stream nextPutAll: '<no>' ].
		stream nextPutAll: (self orderSpecs at: anIndex) key ]! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/17/2012 18:04'!
repositories

	^ repositories! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 18:20'!
repositoriesOfWorkingCopy: aWorkingCopy
	
	^ aWorkingCopy isNil
		ifFalse: [ aWorkingCopy repositoryGroup repositories]
		ifTrue: [ self allRepositories]	! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/17/2012 18:04'!
workingCopies

	^ workingCopies! !

!MonticelloRepositoryBrowser methodsFor: 'protocol' stamp: 'SD 4/19/2012 16:12'!
workingCopies: aCollection
	"Set the value of the list widget"
	
	workingCopies items: aCollection ! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 6/2/2012 20:29'!
workingCopiesFromMC
	^ (self orderSpecs size = order
		ifTrue: [ self allManagers select: [ :each | each modified ] ]
		ifFalse: [ self allManagers ])
			asSortedCollection: (self orderSpecs at: order) value.! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/19/2012 18:17'!
workingCopiesMenu: aMenu


	aMenu target: self;
		add: 'Browse working copy' action: #browseWorkingCopy.

	1 to: self orderSpecs size do: [ :index | 
		aMenu
			addUpdating: #orderString:
			target: self
			selector: #order:
			argumentList: {index} ].
	^ aMenu! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 18:20'!
workingCopy
	^ workingCopies selectedItem! !

ComposableModel subclass: #STEditor
	instanceVariableNames: 'object ok text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
buildWithSpec

	^ self buildWithSpecLayout: self layout! !

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
buildWithSpec: aSpec

	^ self buildWithSpecLayout: self layout! !

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
help: aString 
	
	text help: aString ! !

!STEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/12/2012 18:18'!
initialize
	"Initialization code for BlocEditor"

	super initialize.

	object := nil asValueHolder! !

!STEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/12/2012 18:25'!
initializeWidgets 

	self  instantiateModels: #( 
		text 	TextInputFieldModel
		ok 		ButtonModel ).

	text
		autoAccept: false;
		entryCompletion: nil;
		acceptBlock: [ self okAction ];
		ghostText: 'st code'.
		
	ok 
		label: 'ok';
		state: false;
		enabled: true;
		action: [ self okAction ].
		
	self focusOrder 
		add: text;
		add: ok! !

!STEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
layout

	^ SpecLayout composed 
		newRow: [:r |
			r
				add: #text;
				newColumn: [:c | c add: #ok ] width: 25 ]
		 height: 25;
		yourself! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
object

	^ object contents! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
object: aBlock

	object contents: aBlock ! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
ok

	^ ok! !

!STEditor methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/12/2012 18:19'!
okAction

	text accept.
	object contents: (Compiler evaluate: text getText).! !

!STEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/12/2012 18:20'!
text
	^ text! !

!STEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/12/2012 18:19'!
whenObjectChangedDo: aBlock

	object whenChangedDo: aBlock ! !

ComposableModel subclass: #WidgetSetter
	instanceVariableNames: 'apiSetters model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

WidgetSetter subclass: #WidgetEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Editor'!

!WidgetSetter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/11/2012 16:33'!
spec
	<spec>
		
	^ SpecLayout composed
		add: #apiSetters;
		yourself! !

!WidgetSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 16:32'!
apiSetters

	^ apiSetters! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:41'!
buildBlockItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: BlockApiSetter.! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:41'!
buildBooleanItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: BooleanApiSetter! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:41'!
buildColorItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: ColorApiSetter! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/12/2012 17:40'!
buildDoItemFor: anAPIMethod 

	^ nil! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 17:21'!
buildEventItemFor: anAPIMethod 

	^ nil! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/11/2012 17:21'!
buildInspectItemFor: anAPIMethod 

	^ nil! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 22:08'!
buildIntegerItemFor: anAPIMethod 
	| pragma arguments retrievingMethod item |
	
	pragma := anAPIMethod pragmas detect: [ :e | e keyword beginsWith: #api:min:max:getter: ] ifNone: [ nil ].
	
	pragma 
		ifNil: [  
			arguments := #().
			retrievingMethod  := nil ]
		ifNotNil: [ 
			arguments := pragma arguments.
			retrievingMethod := arguments fourth ].
		
	item := IntegerApiSetter new
				model: self model;
				method: anAPIMethod selector;
				retrievingMethod: retrievingMethod;
				yourself.
	
	arguments size > 5 ifTrue: [
		self model 
				perform: arguments fifth
				with: [:newValue | item updateWith: newValue ]].
	
	^ item ! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 19:28'!
buildItemFor: anAPIMethod
	| args first |
	
	args := (anAPIMethod pragmas detect: [ :e | e keyword beginsWith: 'api:' ] ifNone: [ ^ nil ]) arguments.
	first := args first.

	first = #boolean
		ifTrue: [ ^ self buildBooleanItemFor: anAPIMethod ].
	first = #string
		ifTrue: [ ^ self buildStringItemFor: anAPIMethod ].
	first = #block
		ifTrue: [ ^ self buildBlockItemFor: anAPIMethod ].
	first = #inspect
		ifTrue: [ ^ self buildInspectItemFor: anAPIMethod ].
	first = #do
		ifTrue: [ ^ self buildDoItemFor: anAPIMethod ].
	first = #st
		ifTrue: [ ^ self buildStItemFor: anAPIMethod ].
	first = #integer
		ifTrue: [ ^ self buildIntegerItemFor: anAPIMethod ].
	first = #color
		ifTrue: [ ^ self buildColorItemFor: anAPIMethod  ].
	first = #event
		ifTrue: [ ^ self buildEventItemFor: anAPIMethod  ].
		
	^ self halt.! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 22:08'!
buildItemFor: anAPIMethod kind: aClass
	| pragma arguments retrievingMethod item |
	
	pragma := anAPIMethod pragmas detect: [ :e | e keyword beginsWith: #api:getter: ] ifNone: [ nil ].
	
	pragma 
		ifNil: [  
			arguments := #().
			retrievingMethod  := nil ]
		ifNotNil: [ 
			arguments :=pragma arguments.
			retrievingMethod := arguments second ].
		
	item := aClass new
				model: self model;
				method: anAPIMethod selector;
				retrievingMethod: retrievingMethod;
				yourself.
				
	arguments size >2 
		ifTrue: [ 
			self model 
					perform: arguments third
					with: [:newValue | item updateWith: newValue ]].
	
	^ item ! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:42'!
buildStItemFor: anAPIMethod 

	^ self buildItemFor: anAPIMethod kind: StApiSetter! !

!WidgetSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/16/2012 19:42'!
buildStringItemFor: anAPIMethod

	^ self buildItemFor: anAPIMethod kind: StringApiSetter! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 18:31'!
initialize
	"Initialization code for WidgetSetter"

	model := nil asValueHolder.
	model whenChangedDo: [:m || max |
		self updateTitle.
		apiSetters items: self retrieveItems.
		max := (apiSetters listItems collect:[:e | self widthFor: e method ]) ifEmpty: [ 0 ] ifNotEmpty: [:l | l max ].
		apiSetters listItems do: [:e | e selectorWidth: max ]].
	
	super initialize.

! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 16:33'!
initializeWidgets 
	
	self instantiateModels: #( apiSetters ListComposableModel ).
	
	apiSetters 
		allowToSelect: false;
		displayBlock: [:e | e ];
		items: self retrieveItems.! !

!WidgetSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 16:32'!
model

	^ model contents! !

!WidgetSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/11/2012 16:32'!
model: anObject

	model contents: anObject! !

!WidgetSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/16/2012 18:47'!
openWithSpec 

	super openWithSpec.
	apiSetters widget ifNotNil: [:w || wdw height |
		height := apiSetters listItems inject: 0 into: [:s :e | s + e widget height ].

		wdw := self window widget.
		wdw height: height + wdw labelArea height + 12.
		wdw width: 470 ]! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/16/2012 18:20'!
retrieveItems

	^ self model 
		ifNil: [ #() ]
		ifNotNil: [:m | ((m apiMethods sort: [:a :b | a selector < b selector ]) collect: [:e | self buildItemFor: e ]) reject: [:e | e isNil ]]! !

!WidgetSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/11/2012 19:32'!
title

	^ self model
		ifNil: [ 'Widget Editor' ]
		ifNotNil: [:m | 'Widget Editor: ', m class name ]! !

!WidgetSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/11/2012 19:31'!
widthFor: selector
	
	apiSetters widget ifNil: [ ^ StandardFonts listFont widthOfString: selector ].
	^ selector widthToDisplayInList: apiSetters widget! !

ComposableModel subclass: #WorkingCopyToolBar
	instanceVariableNames: 'browseButton configButton packageButton sliceButton workingCopyHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!WorkingCopyToolBar commentStamp: '<historical>' prior: 0!
WorkingCopyToolBar new openWithSpec!

!WorkingCopyToolBar class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:54'!
defaultSpec 

	^ {#ComposableSpec.
			#add: . {{#model . #packageButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0@0 corner: 0.25@0 . 
											0@0 corner: 0@25 }} . 

#add: . {{#model . #configButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.25@0 corner: 0.50@0 . 
											0@0 corner: 0@25 }} . 
											
#add: . {{#model . #sliceButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.50@0 corner: 0.75@0 . 
											0@0 corner: 0@25 }} . 											

#add: . {{#model . #browseButton.} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.75@0 corner: 1@0 . 
											0@0 corner: 0@25 }} 	
		}! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:33'!
browseButton
	^ browseButton! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:34'!
configButton
	
	^ configButton! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:42'!
createPackage
	| name |
	
	name := UIManager default request: 'Name of package:' translated.
	name isEmptyOrNil ifFalse:
		[ PackageInfo registerPackageName: name.
		MCWorkingCopy forPackage: (MCPackage new name: name).]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:45'!
initialize
	"Initialization code for WorkingCopyToolBar"

	super initialize.
	workingCopyHolder := nil asValueHolder! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
initializeWidgets

	self instantiateModels: #(
		browseButton  ButtonModel
		configButton  ButtonModel
		packageButton ButtonModel ).
		
	self setBrowseButton.
	self setConfigButton.
	self setPackageButton.
	self setSliceButton.! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:32'!
packageButton

	^ packageButton! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setBrowseButton

	browseButton
		state: false;
		enabled: false;
		label: 'Browse';
		help: 'Browse the working copy of the selected package';
		action: [ self browseWorkingCopy ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setConfigButton

	configButton
		state: false;
		label: '+Config';
		help: 'Add a new metacello configuration';
		action: [ self createConfiguration ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setPackageButton

	packageButton
		state: false;
		label: '+Package';
		help: 'Add a new package and make it the working copy';
		action: [ self createPackage ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 6/12/2012 18:44'!
setSliceButton
	sliceButton := self instantiate: ButtonModel.
	sliceButton
		state: false;
		label: '+Slice';
		help: 'Add a slice to cleaning and nicely propose a bug fix';
		action: [ self createSlice ]! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:34'!
sliceButton
	
	^ sliceButton! !
